// ComplexInterpolyBySadko.cpp:      .
//

#include "stdafx.h"
#include "ComplexN.h"
#include "InterpolyEng.h"

void CalcPoly(COMPLEX Poly[], unsigned int PolyLength, COMPLEX* z, COMPLEX* Result)
{
	ZeroMemory(Result, sizeof(COMPLEX));

	for (unsigned int i = PolyLength; i > 0; i--)
	{
		ComplexMul(Result, Result, z);

		ComplexAdd(Result, Result, &Poly[i - 1]);
	}
}

#define Threshold 2

FloatType CalcErrOnNPoints(unsigned int N)
{
	COMPLEX_POINT* Points = (COMPLEX_POINT*)malloc(N*sizeof(COMPLEX_POINT));
	COMPLEX* Poly = (COMPLEX*)malloc(N*sizeof(COMPLEX));

	for (unsigned int i = 0; i < N; i++)
	{
		ComplexRandom(&Points[i].x, -Threshold, Threshold, -Threshold, Threshold);
		ComplexRandom(&Points[i].y, -Threshold, Threshold, -Threshold, Threshold);
	}

	Interpoly(Points, N, Poly);

	FloatType TotErr = 0;
	for (unsigned int i = 0; i < N; i++)
	{
		COMPLEX Val;
		CalcPoly(Poly, N, &Points[i].x, &Val);
		ComplexSub(&Val, &Points[i].y, &Val);

		TotErr += Val.A;
	}
	TotErr /= N;

	free(Poly);
	free(Points);

	return TotErr;
}

FloatType CalcErrOnMItersNPoints(unsigned int M, unsigned int N)
{
	FloatType Result = 0;
	for (unsigned int i = 0; i < M; i++)
	{
		Result += CalcErrOnNPoints(N);
	}
	Result /= M;

	return Result;
}

#define ArrSize 100

int _tmain(int argc, _TCHAR* argv[])
{
	LARGE_INTEGER t;
	QueryPerformanceCounter(&t);
	srand(t.LowPart^t.HighPart);

	/*FloatType Err = CalcErrOnNPoints(ArrSize);
	printf("\nErr=%e\n", Err);*/

	FILE* f;
	fopen_s(&f, "C:\\temp\\InterpolyBySadKo.csv", "w");

	fwrite("Poly deg;Error\n", strlen("Poly deg;Error\n"), 1, f);

	unsigned int Pc, PrevPc = 0;

	for (unsigned int i = 1; i <= ArrSize; i++)
	{
		FloatType Err = CalcErrOnMItersNPoints(1000, i);

		char s[256];
		sprintf_s(s, 256, "%u;%e\n", i, Err);

		fwrite(s, strlen(s), 1, f);

		Pc = 100 * i / ArrSize;
		if (Pc != PrevPc)
		{
			PrevPc = Pc;
			printf("%u%% - done\n", Pc);
		}
	}

	fclose(f);
	printf("DONE!\n");

	int qwe;
	scanf_s("%d", &qwe);
	return 0;
}

