#include "stdafx.h"
#include "InterpolyEng.h"

void GetM(COMPLEX_POINT Points[], unsigned int StartIndex, unsigned int MiddleIndex, unsigned int EndIndex, COMPLEX* M)
{
	COMPLEX tmp;

	M->A = 1;
	M->NRe = 1;
	M->NIm = 0;

	if (MiddleIndex > StartIndex)
	{
		for (unsigned int i = StartIndex; i < MiddleIndex; i++)
		{
			ComplexSub(&tmp, &Points[i].x, &Points[MiddleIndex].x);
			ComplexMul(M, M, &tmp);
		}
	}

	if (MiddleIndex < EndIndex)
	{
		for (unsigned int i = MiddleIndex + 1; i <= EndIndex; i++)
		{
			ComplexSub(&tmp, &Points[MiddleIndex].x, &Points[i].x);
			ComplexMul(M, M, &tmp);
		}
	}
}

void GetCoef(COMPLEX_POINT Points[], unsigned int NumOfPoints, COMPLEX LocArr[], unsigned int index, COMPLEX* Result)
{
	ZeroMemory(Result, sizeof(COMPLEX));

	for (unsigned int i = 0; i <= index; i++)
	{
		COMPLEX M;
		GetM(Points, 0, i, index, &M);

		COMPLEX tmp;
		CopyMemory(&tmp, &LocArr[i], sizeof(COMPLEX));
		if (i % 2 == 1)
		{
			tmp.NRe = -tmp.NRe;
			tmp.NIm = -tmp.NIm;
		}

		ComplexDiv(&tmp, &tmp, &M);
		ComplexAdd(Result, Result, &tmp);
	}
}

void Interpoly(COMPLEX_POINT Points[], unsigned int NumOfPoints, COMPLEX Poly[])
{
	if (NumOfPoints > 0)
	{
		COMPLEX* LocArr = (COMPLEX*)malloc(sizeof(COMPLEX)*NumOfPoints);

		for (unsigned int i = 0; i < NumOfPoints; i++)
		{
			LocArr[i] = Points[i].y;
		}

		for (unsigned int i = NumOfPoints; i>0; i--)
		{
			GetCoef(Points, NumOfPoints, LocArr, i - 1, &Poly[i - 1]);

			for (unsigned int j = 0; j < i; j++)
			{
				COMPLEX tmp;

				ComplexIntPow(&tmp, &Points[j].x, i - 1);
				ComplexMul(&tmp, &tmp, &Poly[i - 1]);
				ComplexSub(&LocArr[j], &LocArr[j], &tmp);
			}
		}

		free(LocArr);
	}
}